//*********************************************************
//
// Copyright (c) Microsoft. All rights reserved.
// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
//
//*********************************************************

//
// PrimeCalculator.h
//

#include "stdafx.h"
#include <vector>

using namespace std;

_declspec(dllexport) vector<int> get_primes(int max);
void add_prime(int n, vector<int>& primes);
bool is_factor(int n, int i);
bool has_factors(int n);
bool is_base(int n);
bool is_prime(int n);

vector<int> get_primes(int max)
{
	vector<int> primes;
	for (int n = 0; n < max; n++)
	{
		if (is_prime(n)) {
			add_prime(n, primes);
		}
	}
	return primes;
}

bool is_prime(int n)
{
	if (is_base(n))
		return false;
	if (has_factors(n))
		return false;
	return true;
}

bool is_base(int n)
{
	if (n < 2)
		return true;
	return false;
}

bool has_factors(int n)
{
	for (int i = 2; i < n; ++i)
	{
		if (is_factor(n, i))
			return true;
	}
	return false;
}

bool is_factor(int n, int i){
	if ((n % i) == 0)
		return true;
	return false;
}

void add_prime(int n, vector<int> &primes)
{
	primes.push_back(n);
}
